%{
enum { AX=0, CX=1, DX=2, BX=3 , SI=4, DI=5, DS=6, ES=7 };
#include <limits.h>
#include "c.h"
char *highbyte[]={"ah","ch","dh","bh","ERROR","ERROR","ERROR","ERROR"};
char *highword[]={"dx","bx","ERROR","ERROR","ds","es","ERROR","ERROR"};
#define NODEPTR_TYPE Node
#define OP_LABEL(p) ((p)->op)
#define LEFT_CHILD(p) ((p)->kids[0])
#define RIGHT_CHILD(p) ((p)->kids[1])
#define STATE_LABEL(p) ((p)->x.state)
static void address(Symbol, Symbol, int);
static void blkfetch(int, int, int, int);
static void blkloop(int, int, int, int, int, int[]);
static void blkstore(int, int, int, int);
static void defaddress(Symbol);
static void defconst(int, int, Value);
static void defstring(int, char *);
static void defsymbol(Symbol);
static void doarg(Node);
static void emit2(Node);
static void export(Symbol);
static void clobber(Node);
static void function(Symbol, Symbol [], Symbol [], int);
static void global(Symbol);
static void import(Symbol);
static void local(Symbol);
static void progbeg(int, char **);
static void progend(void);
static void segment(int);
static void space(int);
static void target(Node);
static int ckstack(Node, int);
static int memop(Node);
static int sametree(Node, Node);
static Symbol charreg[32], shortreg[32], lonreg[32], ptrreg[32];
long nbits_set(unsigned long j);
int issmall(Node p);
int seg_ovr(Node p);
int is2n(Node p);
int shiftcost(Node p);

static Symbol charregw, shortregw, lonregw, ptrregw;

static int cseg;
static long segbeg[]={[CODE]12582912,[DATA]8388608,[BSS]8388608,[LIT]0};
static long segend[]={[CODE]12582912,[DATA]8388608,[BSS]8388608,[LIT]0};
static short dsval;
static short esval;
static Symbol quo, rem;

%}
%start stmt

%term CNSTF4=4113
%term CNSTF8=8209
%term CNSTF16=16401

%term CNSTI1=1045
%term CNSTI2=2069
%term CNSTI4=4117
%term CNSTI8=8213

%term CNSTP4=4119

%term CNSTU1=1046
%term CNSTU2=2070
%term CNSTU4=4118
%term CNSTU8=8214


%term ARGB=41

%term ARGF4=4129
%term ARGF8=8225
%term ARGF16=16417

%term ARGI2=2085
%term ARGI4=4133
%term ARGI8=8229

%term ARGP4=4135

%term ARGU2=2086
%term ARGU4=4134
%term ARGU8=8230


%term ASGNB=57

%term ASGNF4=4145
%term ASGNF8=8241
%term ASGNF16=16433

%term ASGNI1=1077
%term ASGNI2=2101
%term ASGNI4=4149
%term ASGNI8=8245

%term ASGNP4=4151

%term ASGNU1=1078
%term ASGNU2=2102
%term ASGNU4=4150
%term ASGNU8=8246


%term INDIRB=73

%term INDIRF4=4161
%term INDIRF8=8257
%term INDIRF16=16449

%term INDIRI1=1093
%term INDIRI2=2117
%term INDIRI4=4165
%term INDIRI8=8261

%term INDIRP4=4167

%term INDIRU1=1094
%term INDIRU2=2118
%term INDIRU4=4166
%term INDIRU8=8262


%term CVFF4=4209
%term CVFF8=8305
%term CVFF16=16497

%term CVFI2=2165
%term CVFI4=4213
%term CVFI8=8309


%term CVIF4=4225
%term CVIF8=8321
%term CVIF16=16513

%term CVII1=1157
%term CVII2=2181
%term CVII4=4229
%term CVII8=8325

%term CVIU1=1158
%term CVIU2=2182
%term CVIU4=4230
%term CVIU8=8326


%term CVPU4=4246


%term CVUI1=1205
%term CVUI2=2229
%term CVUI4=4277
%term CVUI8=8373

%term CVUP4=4279

%term CVUU1=1206
%term CVUU2=2230
%term CVUU4=4278
%term CVUU8=8374


%term NEGF4=4289
%term NEGF8=8385
%term NEGF16=16577

%term NEGI2=2245
%term NEGI4=4293
%term NEGI8=8389


%term CALLB=217

%term CALLF4=4305
%term CALLF8=8401
%term CALLF16=16593

%term CALLI2=2261
%term CALLI4=4309
%term CALLI8=8405

%term CALLP4=4311

%term CALLU2=2262
%term CALLU4=4310
%term CALLU8=8406

%term CALLV=216


%term RETF4=4337
%term RETF8=8433
%term RETF16=16625

%term RETI2=2293
%term RETI4=4341
%term RETI8=8437

%term RETP4=4343

%term RETU2=2294
%term RETU4=4342
%term RETU8=8438

%term RETV=248


%term ADDRGP4=4359


%term ADDRFP4=4375


%term ADDRLP4=4391


%term ADDF4=4401
%term ADDF8=8497
%term ADDF16=16689

%term ADDI2=2357
%term ADDI4=4405
%term ADDI8=8501

%term ADDP4=4407

%term ADDU2=2358
%term ADDU4=4406
%term ADDU8=8502


%term SUBF4=4417
%term SUBF8=8513
%term SUBF16=16705

%term SUBI2=2373
%term SUBI4=4421
%term SUBI8=8517

%term SUBP4=4423

%term SUBU2=2374
%term SUBU4=4422
%term SUBU8=8518


%term LSHI2=2389
%term LSHI4=4437
%term LSHI8=8533

%term LSHU2=2390
%term LSHU4=4438
%term LSHU8=8534


%term MODI2=2405
%term MODI4=4453
%term MODI8=8549

%term MODU2=2406
%term MODU4=4454
%term MODU8=8550


%term RSHI2=2421
%term RSHI4=4469
%term RSHI8=8565

%term RSHU2=2422
%term RSHU4=4470
%term RSHU8=8566


%term BANDI2=2437
%term BANDI4=4485
%term BANDI8=8581

%term BANDU2=2438
%term BANDU4=4486
%term BANDU8=8582


%term BCOMI2=2453
%term BCOMI4=4501
%term BCOMI8=8597

%term BCOMU2=2454
%term BCOMU4=4502
%term BCOMU8=8598


%term BORI2=2469
%term BORI4=4517
%term BORI8=8613

%term BORU2=2470
%term BORU4=4518
%term BORU8=8614


%term BXORI2=2485
%term BXORI4=4533
%term BXORI8=8629

%term BXORU2=2486
%term BXORU4=4534
%term BXORU8=8630


%term DIVF4=4545
%term DIVF8=8641
%term DIVF16=16833

%term DIVI2=2501
%term DIVI4=4549
%term DIVI8=8645

%term DIVU2=2502
%term DIVU4=4550
%term DIVU8=8646


%term MULF4=4561
%term MULF8=8657
%term MULF16=16849

%term MULI2=2517
%term MULI4=4565
%term MULI8=8661

%term MULU2=2518
%term MULU4=4566
%term MULU8=8662


%term EQF4=4577
%term EQF8=8673
%term EQF16=16865

%term EQI2=2533
%term EQI4=4581
%term EQI8=8677

%term EQU2=2534
%term EQU4=4582
%term EQU8=8678


%term GEF4=4593
%term GEF8=8689
%term GEF16=16881

%term GEI2=2549
%term GEI4=4597
%term GEI8=8693

%term GEU2=2550
%term GEU4=4598
%term GEU8=8694

%term GTF4=4609
%term GTF8=8705
%term GTF16=16897

%term GTI2=2565
%term GTI4=4613
%term GTI8=8709

%term GTU2=2566
%term GTU4=4614
%term GTU8=8710

%term LEF4=4625
%term LEF8=8721
%term LEF16=16913

%term LEI2=2581
%term LEI4=4629
%term LEI8=8725

%term LEU2=2582
%term LEU4=4630
%term LEU8=8726

%term LTF4=4641
%term LTF8=8737
%term LTF16=16929

%term LTI2=2597
%term LTI4=4645
%term LTI8=8741

%term LTU2=2598
%term LTU4=4646
%term LTU8=8742

%term NEI2=2613
%term NEI4=4661
%term NEI8=8757

%term NEU2=2614
%term NEU4=4662
%term NEU8=8758

%term JUMPV=584

%term LABELV=600
%term LOADB=233
%term LOADF4=4321
%term LOADF8=8417
%term LOADF16=16609
%term LOADI1=1253
%term LOADI2=2277
%term LOADI4=4325
%term LOADI8=8421
%term LOADP4=4327
%term LOADP8=8423
%term LOADU1=1254
%term LOADU2=2278
%term LOADU4=4326
%term LOADU8=8422
 

%term VREGP=711
%%
creg:  INDIRI1(VREGP)     "# read register\n"
creg:  INDIRU1(VREGP)     "# read register\n"

sreg:  INDIRI2(VREGP)     "# read register\n"
sreg:  INDIRU2(VREGP)     "# read register\n"

freg:  INDIRF4(VREGP)     "# read register\n"
lreg:  INDIRI4(VREGP)     "# read register\n"
preg:  INDIRP4(VREGP)     "# read register\n"
lreg:  INDIRU4(VREGP)     "# read register\n"

freg:  INDIRF8(VREGP)     "# read register\n"
freg:  INDIRI8(VREGP)     "# read register\n"
freg:  INDIRU8(VREGP)     "# read register\n"


creg: LOADI1(creg) "# move\n" 2
sreg: LOADI2(sreg) "# move\n" 2
lreg: LOADI4(lreg) "# move\n" 2
creg: LOADU1(creg) "# move\n" 2
sreg: LOADU2(sreg) "# move\n" 2
lreg: LOADU4(lreg) "# move\n" 2
preg: LOADP4(preg) "# preg move\n" 2


con: CNSTI1  "%a"
con: CNSTU1  "%a"

con: CNSTI2  "%a"
con: CNSTU2  "%a"

con: CNSTI4  "%a"
con: CNSTU4  "%a"
con: CNSTP4  "%a"

con: CNSTI8  "%a"
con: CNSTU8  "%a"

con0: CNSTI2 "%a" range(a, 0, 0)
con0: CNSTU2 "%a" range(a, 0, 0)
con1: CNSTI1 "%a" range(a, 1, 1)
con1: CNSTU1 "%a" range(a, 1, 1)
con1: CNSTI2 "%a" range(a, 1, 1)
con1: CNSTU2 "%a" range(a, 1, 1)

con2n: CNSTU2 "%a" is2n(a)
con2n: CNSTI2 "%a" is2n(a)

smallconst: CNSTI2 "%a" issmall(a)
smallconst: CNSTU2 "%a" issmall(a)

bit8: CNSTU1 "%a" range(a, 0, 255)
bit8: CNSTU2 "%a" range(a, 0, 255)
bit8: CNSTI1 "%a" range(a,-128,127)
bit8: CNSTI2 "%a" range(a,-128,127)
bit16: CNSTU2 "%a" range(a, 0, 65535)
bit16: CNSTI2 "%a" range(a, -32768, 32767)

stack: ADDRFP4 "bp+(%a)"  5
stack: ADDRLP4 "bp+(%a)"  5

creg: INDIRI1(stack) "mov %c,byte [%0]\n"
sreg: INDIRI2(stack) "mov %c,word [%0]\n"
lreg: INDIRI4(stack) "mov loword_%c,word [%0]\nmov hiword_%c,word [%0+2]\n"
m8:  INDIRI1(preg)  "sreg_%0:oreg_%0" (seg_ovr(a)+5)
m16: INDIRI2(preg) "sreg_%0:oreg_%0" (seg_ovr(a)+5)
m32: INDIRI4(preg)  "sreg_%0:oreg_%0" (seg_ovr(a)*2+16)


rm8: m8 "byte [%0]" 6
rm8: creg  "%0"
rmi8: rm8 "%0"
rmi8: bit8 "%0" 2
rm16: m16 "word [%0]" 6
rm16: sreg "%0" 2
rmi16: rm16 "%0" 
rmi16: bit16 "%0" 2

shift: sreg "cl" 5
shift: creg "cl" 5
shift: con1 "1"

acon: ADDRGP4 "%a"
acon: CNSTP4 "%a"

preg: INDIRP4(acon)  "# load constant pointer into ptr register\n"
preg: INDIRP4(stack) "# load ptr register from stack\n"
creg: INDIRI1(acon)  "# load register from constant pointer\n"
creg: INDIRU1(acon)  "# load register from constant pointer\n"
sreg: INDIRI2(acon)  "# load register from constant pointer\n"
sreg: INDIRU2(acon)  "# load register from constant pointer\n"
lreg: INDIRI4(acon)  "# load register from constant pointer\n"
lreg: INDIRU4(acon)  "# load register from constant pointer\n"

lreg: CVIU4(lreg) "%0" notarget(a)
lreg: CVIU4(sreg) "?mov loword_%c,%0\nxor hiword_%c,hiword_%c\n" 4
lreg: CVIU4(creg) "?mov lobyte_%c,%0\nxor hibyte_%c,hibyte_%c\nxor hiword_%c,hiword_%c\n" 6
lreg: CVUI4(lreg) "%0" notarget(a)
lreg: CVUI4(sreg) "?mov loword_%c,%0\ncwd\n"  5
lreg: CVUI4(creg) "?mov lobyte_%c,%0\ncbw\ncwd" 7
preg: CVPU4(lreg) "# convert UL to pointer\n"
lreg: CVPU4(preg) "# convert pointer to UL\n"

lreg: CVII4(sreg) "?mov loword_%c,%0\ncwd\n" 5
lreg: CVII4(creg) "?mov loword_%c,%0\ncbw\ncwd\n" 7

lreg: CVUU4(sreg) "?mov loword_%c,%0\nxor hiword_%c,hiword_%c\n" 4
lreg: CVUU4(creg) "?mov loword_%c,%0\nxor hiword_%c,hiword_%c\nxor hibyte_%c,hibyte_%c\n" 6

lreg: con0 "xor loword_%c,loword_%c\nxor hiword_%c,hiword_%c\n" 6
lreg: con  "mov loword_%c,((%a) & 0FFFFh)\nmov hiword_%c,((%a)/10000h)\n" 8
lreg: NEGI4(lreg) "# negate long\n" 

lreg: ADDI4(lreg,m32)  "?movl %c,%0\nadd loword_%c,word [%1]\nadc hiword_%c,word[%1+2]\n" 
lreg: SUBI4(lreg,m32)  "?movl %c,%0\nsub loword_%c,word [%1]\nsbb hiword_%c,word[%1+2]\n" 
lreg: BANDU4(lreg,m32)  "?movl %c,%0\nand loword_%c,word [%1]\nand hiword_%c,word [%1+2]\n" 
lreg: BANDI4(lreg,m32)  "?movl %c,%0\nand loword_%c,word [%1]\nand hiword_%c,word [%1+2]\n" 
lreg: BXORU4(lreg,m32)  "?movl %c,%0\nxor loword_%c,word [%1]\nxor hiword_%c,word [%1+2]\n" 
lreg: BXORI4(lreg,m32)  "?movl %c,%0\nxor loword_%c,word [%1]\nxor hiword_%c,word [%1+2]\n" 
lreg: LSHI4(lreg,rmi8)  "# left shift long\n"
lreg: LSHU4(lreg,rmi8)  "# left shift long\n"
lreg: RSHI4(lreg,rmi8)  "# right signed shift long\n"
lreg: RSHU4(lreg,rmi8)  "# right unsigned shift long\n"

lreg: ADDI4(lreg,lreg) "?movl %c,%0\nadd loword_%c,loword_%1\nadc hiword_%c,hiword_%1\n" 7
lreg: SUBI4(lreg,lreg) "?movl %c,%0\nsub loword_%c,loword_%1\nsbb hiword_%c,hiword_%1\n" 7
lreg: BANDU4(lreg,lreg) "?movl %c,%0\nand loword_%c,loword_%1\nand hiword_%c,hiword_%1\n" 6
lreg: BANDI4(lreg,lreg) "?movl %c,%0\nand loword_%c,loword_%1\nand hiword_%c,hiword_%1\n" 6
lreg: BORI4(lreg,lreg) "?movl %c,%0\nor loword_%c,loword_%1\nor hiword_%c,hiword_%1\n" 6
lreg: BXORI4(lreg,lreg) "?movl %c,%0\nxor loword_%c,loword_%1\nxor hiword_%c,hiword_%1\n" 6

lreg: ADDI4(lreg,sreg) "?movl %c,%0\nadd loword_%c,%1\nadc hiword_%c,0\n" 7
lreg: SUBI4(lreg,sreg) "?movl %c,%0\nsub loword_%c,%1\nsbb hiword_%c,0\n" 7
lreg: BANDU4(lreg,sreg) "?movl %c,%0\nand loword_%c,%1\nxor hiword_%c,hiword_%c\n" 6
lreg: BANDI4(lreg,sreg) "?movl %c,%0\nand loword_%c,%1\nxor hiword_%c,hiword_%c\n" 6
lreg: BORI4(lreg,sreg) "?movl %c,%0\nor loword_%c,%1\n" 3
lreg: BANDU4(lreg,CVUI4(sreg)) "?movl %c,%0\nand loword_%c,%1\nxor hiword_%c,hiword_%c\n" 6

lreg: MULU2(sreg,con0) "xor loword_%c,loword_%c\nxor hiword_%c,hiword_%c\n"
lreg: MULI2(sreg,con0) "xor loword_%c,loword_%c\nxor hiword_%c,hiword_%c\n"
lreg: MULU2(sreg,con1) "?mov loword_%c,%0\nxor hiword_%c,hiword_%c\n"
lreg: MULI2(sreg,con1) "# sign extend\n" 
lreg: MULU2(sreg,rm16) "?mov loword_%c,%0\nmul %1\n" 77
lreg: MULI2(sreg,rm16) "?mov loword_%c,%0\nimul %1\n" 98
lreg: MULU4(lreg,m32)  "?movl %c, %0\nmov cx,ax\nmul word [%1+2]\nxchg ax,bx\nmul word [%1]\nadd bx,ax\nmov ax,word [%1]\nmul cx\nadd bx,dx\n"
lreg: MULI4(lreg,m32)  "?movl %c, %0\nmov cx,ax\nmul word [%1+2]\nxchg ax,bx\nmul word [%1]\nadd bx,ax\nmov ax,word [%1]\nmul cx\nadd bx,dx\n"
lreg: MULU2(sreg,smallconst) "# multiply by small constant\n"

lreg: DIVU4(lreg,m32)  "# divide long by long\n"
lreg: MODU4(lreg,m32)  "# mod long by long\n"


sreg: CVIU2(lreg) "?mov %c,loword_%0\n"
sreg: CVIU2(sreg) "%0" notarget(a)
sreg: CVIU2(creg) "# zero extend\n"
sreg: CVUI2(lreg) "?mov %c,loword_%0\n"
sreg: CVUI2(sreg) "%0" notarget(a)
sreg: CVUI2(creg) "# sign extend\n"
sreg: CVII2(creg) "cbw\n"

sreg: con0 "xor %c,%c\n" 3
sreg: rmi16 "mov %c,%a\n" 2
sreg: NEGI2(rmi16) "?mov %c,%0\nneg %0\n" 3

sreg: ADDI2(sreg,rmi16) "?mov %c,%0\nadd %c,%1\n" 3
sreg: SUBI2(sreg,rmi16) "?mov %c,%0\nsub %c,%1\n" 3
sreg: BANDU2(sreg,rmi16) "?mov %c,%0\nand %c,%1\n" 3
sreg: BANDI2(sreg,rmi16) "?mov %c,%0\nand %c,%1\n" 3
sreg: BORI2(sreg,rmi16) "?mov %c,%0\nor %c,%1\n" 3
sreg: BXORI2(sreg,rmi16) "?mov %c,%0\nxor %c,%1\n" 3

sreg: LSHI2(rmi16,shift) "?mov %c,%0\nsal %c,%1\n" shiftcost(a)
sreg: LSHU2(rmi16,shift) "?mov %c,%0\nshl %c,%1\n" shiftcost(a)
sreg: RSHI2(rmi16,shift) "?mov %c,%0\nsar %c,%1\n" shiftcost(a)
sreg: RSHU2(rmi16,shift) "?mov %c,%0\nshr %c,%1\n" shiftcost(a)

sreg: ADDI2(sreg,rmi8) "?mov %c,%0\nadd lobyte_%c,%1\nadc hibyte_%c,0\n" 7
sreg: SUBI2(sreg,rmi8) "?mov %c,%0\nsub lobyte_%c,%1\nsbb hibyte_%c,0\n" 7
sreg: BANDU2(sreg,rmi8) "?mov %c,%0\nand lobyte_%c,%1\nxor hibyte_%c,hibyte_%c\n" 7
sreg: BANDI2(sreg,rmi8) "?mov %c,%0\nand lobyte_%c,%1\nxor hibyte_%c,hibyte_%c\n" 7
sreg: BORI2(sreg,rmi8) "?mov %c,%0\nor lobyte_%c,%1\n" 3

sreg: MULU2(sreg,con2n) "# multiply by power of two\n"
sreg: MULI2(sreg,con2n) "# multiply by power of two\n" 
sreg: MULU2(sreg,smallconst) "# multiply by small constant\n"
sreg: MULI2(sreg,smallconst) "# multiply by small constant\n"
sreg: MULU2(smallconst,sreg) "# multiply by small constant\n"
sreg: MULI2(smallconst,sreg) "# multiply by small constant\n"

sreg: DIVU2(sreg,con2n) "# divide by power of two\n"
sreg: DIVI2(sreg,con2n) "# divide by power of two\n"
sreg: MODU2(rm16,con2n) "and %0,%1-1\n"   4
sreg: DIVI2(lreg,rm16)  "idiv %1\n"  165
sreg: DIVI2(sreg,rm16)  "cwd\nidiv %1\n"  170
sreg: MODI2(lreg,rm16)  "idiv %1\n"  165
sreg: MODI2(sreg,rm16)  "cwd\nidiv %1\n"  170

creg: CVIU1(lreg) "?mov %c,lobyte_%0\n"
creg: CVIU1(sreg) "?mov %c,lobyte_%0\n" 
creg: CVIU1(creg) "%0" notarget(a)
creg: CVUI1(lreg) "?mov %c,lobyte_%0\n"
creg: CVUI1(sreg) "?mov %c,lobyte_%0\n" 
creg: CVUI1(creg) "%0" notarget(a)

creg: CNSTI2     "mov %c,%a\n" (3|range(a,-128,127))
creg: CNSTU2     "mov %c,%a\n" (3|range(a,0,256))

creg: con0 "xor %c,%c\n" 3
creg: rmi8  "mov %c,%a\n"  2
creg: CVIU1(NEGI4(CVUI4(creg))) "?mov %c,%0\nneg %0\n" 3
creg: CVIU1(NEGI4(CVUI4(m8)))   "?mov %c,byte [%0]\nneg %0\n" 3

preg: ADDP4(rmi16,acon) "# add short to acon\n"
preg: ADDP4(rmi16,preg) "# add preg to short\n"
preg: ADDP4(preg,rmi16) "# add short to preg\n"
preg: ADDP4(preg,rmi8) "# add char to preg\n"

ri8: creg "%0"
ri8: bit8 "%0"
ri16: sreg "%0"
ri16: bit16 "%0"

stmt: creg ""
stmt: sreg ""
stmt: lreg ""
stmt: freg ""
stmt: LABELV "%a:\n"

stmt: ASGNI1(m8,ri8)   "mov byte [%0],%1\n" 3
stmt: ASGNU1(m8,ri8)   "mov byte [%0],%1\n" 3
stmt: ASGNI1(preg,ri8) "mov byte [sreg_%0:oreg_%0],%1\n" (seg_ovr(a)+8)
stmt: ASGNI2(stack,sreg) "mov word [%0],%1\n" 8
stmt: ASGNI2(preg,ri16) "mov word [sreg_%0:oreg_%0],%1\n" 3
stmt: ASGNI2(m16,ri16) "mov word [%0],%1\n" 3
stmt: ASGNU2(m16,ri16) "mov word [%0],%1\n" 3
stmt: ASGNI2(acon,ri16) "mov ax,(%0 >> 13)\ncall __getseg\nmov ds,ax\nmov ax,%1\n"
stmt: ASGNI4(m32,lreg) "mov word [%0],loword_%1\nmov word [%0+2],hiword_%1\n" 6
stmt: ASGNU4(m32,lreg) "mov word [%0],loword_%1\nmov word [%0+2],hiword_%1\n" 6
stmt: ASGNI4(m32,con)  "mov word [%0],(%1 & 65535)\nmov word [%0+2],(%1 >> 16)\n" 6
stmt: ASGNP4(stack,acon) "mov word [%0],(%1 & 65535)\nmov word [%0+2],(%1 >> 16)\n" 8
preg: acon "mov oreg_%c,(%0 & 3FFFh)\nmov ax,(%0 >> 13)\ncall __getseg\nmov sreg_%c,ax\n" 8

stmt: JUMPV(acon)      "push %a >> 16\npush %a & 0FFFFh\njmp __jmp\n"  (17*2+10)

stmt: EQI2(m16,ri16)   "cmp word [%0],%1\nje %a\n"  19
stmt: GEI2(m16,ri16)   "cmp word [%0],%1\njge %a\n"  19
stmt: GTI2(m16,ri16)   "cmp word [%0],%1\njg %a\n"  19
stmt: LEI2(m16,ri16)   "cmp word [%0],%1\njle %a\n"  19
stmt: LTI2(m16,ri16)   "cmp word [%0],%1\njl %a\n"  19
stmt: NEI2(m16,ri16)   "cmp word [%0],%1\njne %a\n"  19
stmt: GEU2(m16,ri16)   "cmp word [%0],%1\njae %a\n"  19
stmt: GTU2(m16,ri16)   "cmp word [%0],%1\nja %a\n"  19
stmt: LEU2(m16,ri16)   "cmp word [%0],%1\njbe %a\n"  19
stmt: LTU2(m16,ri16)   "cmp word [%0],%1\njb %a\n"  19

stmt: EQI2(sreg,rmi16)   "cmp %0,%1\nje %a\n" 19
stmt: GEI2(sreg,rmi16)   "cmp %0,%1\njge %a\n" 19
stmt: GTI2(sreg,rmi16)   "cmp %0,%1\njg %a\n" 19
stmt: LEI2(sreg,rmi16)   "cmp %0,%1\njle %a\n" 19
stmt: LTI2(sreg,rmi16)   "cmp %0,%1\njl %a\n" 19
stmt: NEI2(sreg,rmi16)   "cmp %0,%1\njne %a\n"  19
stmt: GEU2(sreg,rmi16)   "cmp %0,%1\njae %a\n"  19
stmt: GTU2(sreg,rmi16)   "cmp %0,%1\nja %a\n"  19
stmt: LEU2(sreg,rmi16)   "cmp %0,%1\njbe %a\n"  19
stmt: LTU2(sreg,rmi16)   "cmp %0,%1\njb %a\n"  19

stmt: ARGP4(stack)       "# push global address of a local variable\n"
stmt: ARGP4(acon)        "push %a/65536\npush %a & 0FFFFh\n" (17*2)
stmt: ARGI4(lreg)        "push hiword_%0\npush loword_%0\n" (17*2)
stmt: ARGU4(lreg)        "push hiword_%0\npush loword_%0\n" (17*2)
stmt: ARGI4(m32)         "push word [%0+2]\npush word [%0]\n" (17*2)
stmt: ARGU4(m32)         "push word [%0+2]\npush word [%0]\n" (17*2)
stmt: ARGI2(rm16)        "push %0\n" 17
stmt: ARGU2(rm16)        "push %0\n" 17
stmt: ARGI2(rm16)        "push %0\n" 17
stmt: ARGU2(rm16)        "push %0\n" 17

stmt: CALLV(acon)        "mov dx,%0/65536\nmov ax,%0 & 0FFFFh\ncall __call\nadd sp,%a\n" (17*3)
stmt: CALLI2(acon)        "mov dx,%0/65536\nmov ax,%0 & 0FFFFh\ncall __call\nadd sp,%a\n" (17*3)
stmt: CALLU2(acon)        "mov dx,%0/65536\nmov ax,%0 & 0FFFFh\ncall __call\nadd sp,%a\n" (17*3)
stmt: CALLI4(acon)        "mov dx,%0/65536\nmov ax,%0 & 0FFFFh\ncall __call\nadd sp,%a\n" (17*3)
stmt: CALLU4(acon)        "mov dx,%0/65536\nmov ax,%0 & 0FFFFh\ncall __call\nadd sp,%a\n" (17*3)
stmt: CALLP4(acon)        "mov dx,%0/65536\nmov ax,%0 & 0FFFFh\ncall __call\nadd sp,%a\n" (17*3)

stmt: RETI2(sreg)         "# ret\n"  
stmt: RETV                "jmp __ret\n"  

stmt: ASGNI2(stack, ADDI2(m16,con1)) "inc word [%0]\n" 
stmt: ASGNI1(stack, ADDI2(m8,con1)) "inc byte [%0]\n" 
stmt: ASGNI2(VREGP, ADDI2(sreg,con1)) "?mov %0,%1\ninc %0\n" 
stmt: ASGNI1(VREGP, ADDI2(creg,con1)) "?mov %0,%1\ninc %0\n" 


stmt: ASGNI1(VREGP,creg)  "# write register\n" 
stmt: ASGNU1(VREGP,creg)  "# write register\n"
stmt: ASGNI2(VREGP,sreg)  "# write register\n"
stmt: ASGNU2(VREGP,sreg)  "# write register\n"
stmt: ASGNF4(VREGP,freg)  "# write register\n"
stmt: ASGNI4(VREGP,lreg)  "# write register\n"
stmt: ASGNP4(VREGP,preg)  "# write register\n"
stmt: ASGNU4(VREGP,lreg)  "# write register\n"
stmt: ASGNF8(VREGP,freg)  "# write register\n"
stmt: ASGNI8(VREGP,freg)  "# write register\n"
stmt: ASGNU8(VREGP,freg)  "# write register\n"

%%

#define ck(x) return ((x)?0:LBURG_MAX)

int seg_ovr(Node p) {
  return(0);
}

long nbits_set(unsigned long j) {
  int retval=0,i;
  for (i=0;i<(CHAR_BIT*sizeof(long));i++) {
     retval+=!!(j & (1<<i));
  }
  return(retval);
}

int issmall(Node p) {
  Symbol s = p->syms[0];
  switch (specific(p->op)) {
     case CNST+I: return (nbits_set(s->u.c.v.i)*(15+8));
     case CNST+U: return (nbits_set(s->u.c.v.u)*(15+8));
     case CNST+P: return (nbits_set(s->u.c.v.u)*(15+8)*2);
  }
  return LBURG_MAX;
}


int is2n(Node p) {
	Symbol s = p->syms[0];
	switch (specific(p->op)) {
	  case CNST+I: ck(nbits_set(s->u.c.v.i)==1);
	  case CNST+U: ck(nbits_set(s->u.c.v.u)==1);
	  case CNST+P: ck(nbits_set((unsigned long)(s->u.c.v.p))==1);
	}
	return LBURG_MAX;
}

int shiftcost(Node p) {
        Symbol s = p->syms[0];
	switch (specific(p->op)) {
	  case CNST+I: case CNST+U:
	    return (3+s->u.c.v.i);
	}
	return (8+8*3);
}
  
static void progbeg(int argc, char *argv[]) {
        int i;

        {
                union {
                        char c;
                        int i;
                } u;
                u.i = 0;
                u.c = 1;
                swap = ((int)(u.i == 1)) != IR->little_endian;
        }
        parseflags(argc, argv);

	lonreg[AX] = mkreg("ax", AX, 1, IREG);
	lonreg[AX]->x.regnode->mask |= ((1<<AX) | (1<<DX));
	lonreg[BX] = mkreg("bx", BX, 1, IREG);
	lonreg[BX]->x.regnode->mask |= ((1<<BX) | (1<<CX));

	ptrreg[DI] = mkreg("di", DI, 1, IREG);
	ptrreg[DI]->x.regnode->mask |= (1<<ES);
	ptrreg[SI] = mkreg("si", SI, 1, IREG);
	ptrreg[SI]->x.regnode->mask |= (1<<DS);
	ptrreg[BX] = mkreg("bx", BX, 1, IREG);
	ptrreg[BX]->x.regnode->mask |= ((1<<DS) | (1<<BX));

        shortreg[AX] = mkreg("ax", AX, 1, IREG);
        shortreg[CX] = mkreg("cx", CX, 1, IREG);
        shortreg[DX] = mkreg("dx", DX, 1, IREG);
        shortreg[BX] = mkreg("bx", BX, 1, IREG);

        charreg[AX]  = mkreg("al", AX, 1, IREG);
        charreg[CX]  = mkreg("cl", CX, 1, IREG);
        charreg[DX]  = mkreg("dl", DX, 1, IREG);
        charreg[BX]  = mkreg("bl", BX, 1, IREG);

        charregw = mkwildcard(charreg);
        shortregw = mkwildcard(shortreg);
	ptrregw = mkwildcard(ptrreg);
        lonregw = mkwildcard(lonreg);

        tmask[IREG] = (1<<AX) | (1<<BX) | (1<<CX) | (1<<DX)
		    | (1<<SI) | (1<<DI) | (1<<ES) | (1<<DS);
        vmask[IREG] = 0;
        tmask[FREG] = 0xff;
        vmask[FREG] = 0;
	print("%%define lobyte_ax al\n");
	print("%%define lobyte_bx bl\n");
	print("%%define lobyte_cx cl\n");
	print("%%define lobyte_dx dl\n");
	print("%%define hibyte_ax ah\n");
	print("%%define hibyte_bx bh\n");
	print("%%define hibyte_cx ch\n");
	print("%%define hibyte_dx dh\n");
	print("%%define loword_ax ax\n");
	print("%%define loword_bx bx\n");
	print("%%define hiword_ax dx\n");
	print("%%define hiword_bx cx\n");
	print("%%define sreg_si ds\n");
	print("%%define sreg_di es\n");
	print("%%define sreg_bx ds\n");
	print("%%define oreg_si si\n");
	print("%%define oreg_di di\n");
	print("%%define oreg_bx bx\n");
        print("BITS 16\n");
        cseg = 0;
}

static Symbol rmap(int opk) {
        switch (optype(opk)) {
        case B: case P:
                return ptrregw;
        case I: case U:
                if (opsize(opk) == 1) {
                        return charregw;
		}
                else if (opsize(opk) == 2) {
                        return shortregw;
		}
                else {
                        return lonregw;
		}
        default:
                return 0;
        }
}

static void segment(int n) {
        debug(fprintf(stderr,"segment: %d\n",n));
        if (n == cseg)
                return;
	cseg=n;
        if (cseg == CODE)
                print("SECTION .text\n");
        else if (cseg == DATA)
                print("SECTION .data\n");
	     else if (cseg == BSS || cseg == LIT)
		print("SECTION .bss\n");
}

static void progend(void) {
        segment(0);
        debug(fprintf(stderr,"progend: \n"));
        print("end\n");
}

static void target(Node p) {
        debug(fprintf(stderr,"target: %x\n",p));
        assert(p);
        switch (specific(p->op)) {
        case RSH+I: case RSH+U: case LSH+I: case LSH+U:
                if (!(generic(p->kids[1]->op) == CNST &&
		    (range(p->kids[1],1,1)==0)))
		{
                        rtarget(p, 1, charreg[CX]);
                }
                break;
        case MUL+U:
                setreg(p, lonreg[AX]);
                rtarget(p, 0, lonreg[AX]);
                break;
        case DIV+I: case DIV+U:
                setreg(p, lonreg[AX]);
                rtarget(p, 0, lonreg[AX]);
                rtarget(p, 1, lonreg[BX]);
                break;
        case MOD+I: case MOD+U:
                setreg(p, rem);
                rtarget(p, 0, lonreg[AX]);
                rtarget(p, 1, lonreg[BX]);
                break;
        case ASGN+B:
                rtarget(p, 0, ptrreg[DI]);
                rtarget(p->kids[1], 0, ptrreg[DI]);
                break;
        case ARG+B:
                rtarget(p->kids[0], 0, ptrreg[DI]);
                break;
        case CVF+I:
                setreg(p, lonreg[AX]);
                break;
	case CVU+I: case CVI+I: 
		setreg(p, lonreg[AX]);
		break;
        case CALL+I: case CALL+U: case CALL+V:
                setreg(p, lonreg[AX]);
                break;
	case CALL+P:
		setreg(p, ptrreg[DI]);
		break;
        case RET+I: case RET+U: case RET+P:
                rtarget(p, 0, lonreg[AX]);
                break;
        }
	fflush(stdout);
}

static void clobber(Node p) {
        static int nstack = 0;
        debug(fprintf(stderr,"clobber: %x\n",p));

        assert(p);
        nstack = ckstack(p, nstack);
        switch (specific(p->op)) {
	case INDIR+P: case ASGN+P:
		spill(1<<AX,IREG,p);
	case ADD+P:
		spill(1<<AX | 1<<DX | 1<<CX, IREG, p);
		break;
        case ASGN+B: case ARG+B:
                spill(1<<CX | 1<<SI | 1<<DI, IREG, p);
                break;
	case MUL+U: case MUL+I:
		if (opsize(p->op)==4)
		  spill(1<<CX | 1<<BX, IREG, p);
		break;
        case DIV+U: case DIV+I: case MOD+U: case MOD+I:
		if (opsize(p->op)==4)
		  spill(1<<CX | 1<<BX, IREG, p);
		break;
        case CALL+U: case CALL+I: 
		spill(1<<BX | 1<<CX | 1<<DI | 1<<SI, IREG, p);
		break;
	case CALL+P: case CALL+B:
		spill(1<<AX | 1<<DX | 1<<BX | 1<<CX | 1<<SI, IREG, p);
		break;
		}
}

#define isfp(p) (optype((p)->op)==F)

static int ckstack(Node p, int n) {
        int i;
        debug(fprintf(stderr,"ckstack: %x %d\n",p,n));

        for (i = 0; i < NELEMS(p->x.kids) && p->x.kids[i]; i++)
                if (isfp(p->x.kids[i]))
                        n--;
        if (isfp(p) && p->count > 0)
                n++;
        if (n > 8)
                error("expression too complicated\n");
        debug(fprint(stderr, "(ckstack(%x)=%d)\n", p, n));
        assert(n >= 0);
        return n;
}

static int memop(Node p) {
        assert(p);
        assert(generic(p->op) == ASGN);
        assert(p->kids[0]);
        assert(p->kids[1]);
        if (generic(p->kids[1]->kids[0]->op) == INDIR
        && sametree(p->kids[0], p->kids[1]->kids[0]->kids[0]))
                return 3;
        else
                return LBURG_MAX;
}
static int sametree(Node p, Node q) {
        return p == NULL && q == NULL
        || p && q && p->op == q->op && p->syms[0] == q->syms[0]
                && sametree(p->kids[0], q->kids[0])
                && sametree(p->kids[1], q->kids[1]);
}
static void emit2(Node p) {
        int op = specific(p->op);
#define preg(f) ((f)[getregnum(p->x.kids[0])]->x.name)
        debug(fprintf(stderr,"emit2: specific op = %d\n",op));
        switch (generic(op)) {
	  case INDIR+P:   if (specific(p->kids[0]->op) == ADDRG+P) {
			    char *sym=p->syms[RX]->x.name;
			    print("mov ax,%s>>12\ncall __getseg\n"
				     ,sym);                        
                            return;
			  }
	  case ADD+P:     if (specific(p->kids[1]->op) == ADDRG+P) {
			    char *sym=p->syms[RX]->x.name;
        }
        if (generic(op) == CVI || generic(op) == CVU || generic(op) == LOAD) {
                char *dst = shortreg[getregnum(p)]->x.name;
                char *src = preg(shortreg);
                assert(opsize(p->op) <= opsize(p->x.kids[0]->op));
                if (dst != src)
                        print("mov %s,%s\n", dst, src);
        }
}

static void doarg(Node p) {
        assert(p && p->syms[0]);
        mkactual(4, p->syms[0]->u.c.v.i);
}
static void blkfetch(int k, int off, int reg, int tmp) {}
static void blkstore(int k, int off, int reg, int tmp) {}
static void blkloop(int dreg, int doff, int sreg, int soff,
        int size, int tmps[]) {}

static void local(Symbol p) {
        if (isfloat(p->type))
                p->sclass = AUTO;
        if (askregvar(p, rmap(ttob(p->type))) == 0)
                mkauto(p);
}

static void function(Symbol f, Symbol caller[], Symbol callee[], int n) {
        int i;

        print("%s:\n", f->x.name);
        print("push bp\n");
        print("mov bp,sp\n");
        usedmask[0] = usedmask[1] = 0;
        freemask[0] = freemask[1] = ~(unsigned)0;
        offset = 2 + 4;
        for (i = 0; callee[i]; i++) {
                Symbol p = callee[i];
                Symbol q = caller[i];
                assert(q);
                p->x.offset = q->x.offset = offset;
                p->x.name = q->x.name = stringf("%d", p->x.offset);
                p->sclass = q->sclass = AUTO;
                offset += roundup(q->type->size, 2);
        }
        assert(caller[i] == 0);
        offset = maxoffset = 0;
	debug(fprintf(stderr,"function: calling gencode\n"));
        gencode(caller, callee);
        framesize = roundup(maxoffset, 2);
        if (framesize > 0)
                print("sub sp,%d\n", framesize);

	debug(fprintf(stderr,"function: calling emitcode\n"));
        emitcode();
        print("mov sp,bp\n");
        print("pop bp\n");
        print("ret\n");
}

static void defsymbol(Symbol p) {
        if (p->scope >= LOCAL && p->sclass == STATIC)
                p->x.name = stringf("L%d", genlabel(1));
        else if (p->generated)
                p->x.name = stringf("L%s", p->name);
        else if (p->scope == GLOBAL || p->sclass == EXTERN)
                p->x.name = stringf("_%s", p->name);
        else if (p->scope == CONSTANTS
        && (isint(p->type) || isptr(p->type))
        && p->name[0] == '0' && p->name[1] == 'x')
                p->x.name = stringf("0%sH", &p->name[2]);
        else
                p->x.name = p->name;
}
static void address(Symbol q, Symbol p, int n) {
        if (p->scope == GLOBAL
        || p->sclass == STATIC || p->sclass == EXTERN)
                q->x.name = stringf("%s%s%d",
                        p->x.name, n >= 0 ? "+" : "", n);
        else {
                q->x.offset = p->x.offset + n;
                q->x.name = stringd(q->x.offset);
        }
}
static void defconst(int suffix, int size, Value v) {
        if (suffix == I && size == 1)
                print("db %d\n",   v.u);
        else if (suffix == I && size == 2)
                print("dw %d\n",   v.i);
        else if (suffix == I && size == 4)
                print("dd %d\n",   v.i);
        else if (suffix == U && size == 1)
                print("db 0%xH\n", v.u);
        else if (suffix == U && size == 2)
                print("dw 0%xH\n", v.u);
        else if (suffix == U && size == 4)
                print("dd 0%xH\n", v.u);
        else if (suffix == P && size == 4)
                print("dd 0%xH\n", v.p);
        else if (suffix == F && size == 4) {
                float f = v.d;
                print("dd 0%xg\n", f);
        }
        else if (suffix == F && size == 8) {
                double d = v.d;
                print("dq 0%xg\n", d);
        }
        else assert(0);
}
static void defaddress(Symbol p) {
        print("dd %s\n", p->x.name);
}
static void defstring(int n, char *str) {
        char *s;

        print("db \"%s\"\n",s);
}
static void export(Symbol p) {
        print("public %s\n", p->x.name);
}
static void import(Symbol p) {
        int oldseg = cseg;

        if (p->ref > 0) {
                segment(0);
                print("extrn %s\n", p->x.name);
                segment(oldseg);
        }
}
static void global(Symbol p) {
        static char *rsize[]={"","db 0","dw 0","db 3 dup (0)","dd 0","db 5 dup (0)",
		       "dw 3 dup (0)","db 7 dup (0)","dq 0"};
        print("%s:\n", p->x.name);
	p->x.address=segend[p->u.seg];
	segend[p->u.seg]+=p->type->size;
        if (p->u.seg == BSS)
	  if (p->type->size < 9) 
                print("%s\n", rsize[p->type->size]);
	  else
		print("db %d dup (0)\n", p->type->size);
}
static void space(int n) {
        if (cseg != BSS)
                print("db %d dup (0)\n", n);
}
Interface x8086IR = {
        1, 1, 0,  /* char */
        2, 2, 0,  /* short */
        2, 2, 0,  /* int */
        4, 4, 0,  /* long */
        4, 4, 1,  /* float */
        8, 4, 1,  /* double */
        8, 4, 1,  /* long double */
        4, 4, 0,  /* T * */
        0, 4, 0,  /* struct; so that ARGB keeps stack aligned */
        1,        /* little_endian */
        1,        /* mulops_calls */
        0,        /* wants_callb */
        1,        /* wants_argb */
        0,        /* left_to_right */
        0,        /* wants_dag */
        address,
        blockbeg,
        blockend,
        defaddress,
        defconst,
        defstring,
        defsymbol,
        emit,
        export,
        function,
        gen,
        global,
        import,
        local,
        progbeg,
        progend,
        segment,
        space,
        0, 0, 0, 0, 0, 0, 0,
        {1, rmap,
            blkfetch, blkstore, blkloop,
            _label,
            _rule,
            _nts,
            _kids,
            _string,
            _templates,
            _isinstruction,
            _ntname,
            emit2,
            doarg,
            target,
            clobber,
}
};
