%define SEGMENT EXTERN
%define lobyte_ax al
%define lobyte_bx bl
%define lobyte_cx cl
%define lobyte_dx dl
%define hibyte_ax ah
%define hibyte_bx bh
%define hibyte_cx ch
%define hibyte_dx dh
%define loword_ax ax
%define loword_bx bx
%define hiword_ax dx
%define hiword_bx cx
%define sreg_si ds
%define sreg_di es
%define oreg_si si
%define oreg_di di
%define preg_si si
%define preg_di es:di
%define loword(x) ((x) & 0FFFFh)
%define hiword(x) ((x) >> 16)

%macro bnz 1
jz %%z
jmp %1
%%z:
%endmacro

%macro bz 1
jnz %%nz
jmp %1
%%nz:
%endmacro

%macro bne 1
je %%e
jmp %1
%%e:
%endmacro

%macro be 1
jne %%ne
jmp %1
%%ne:
%endmacro

%macro bb 1
jae %%ae
jmp %1
%%ae:
%endmacro

%macro bbe 1
ja %%a
jmp %1
%%a:
%endmacro

%macro ba 1
jbe %%be
jmp %1
%%be:
%endmacro

%macro bae 1
jb %%b
jmp %1
%%b:
%endmacro

%macro ble 1
jg %%g
jmp %1
%%g:
%endmacro

%macro blt 1
jge %%ge
jmp %1
%%ge:
%endmacro

%macro bge 1
jl %%l
jmp %1
%%l:
%endmacro

%macro bg 1
jle %%le
jmp %1
%%le:
%endmacro

%macro lti4_m32_con 3
cmp word [%1+2],((%2) >> 16)
jl %%lti4
jne %%elti4
cmp word [%1],((%2) & 0FFFFh)
jae %%elti4
%%lti4:
jmp %3
%%elti4:
%endmacro

%macro lti4_m32_r32 4
cmp word [%1+2],%3
jl %%lti4
jne %%elti4
cmp word [%1],%2
jae %%elti4
%%lti4:
jmp %4
%%elti4:
%endmacro

%macro lti4_r32_con 4
cmp %2,((%3) >> 16)
jl %%lti4
jne %%elti4
cmp %1,((%3) & 0FFFFh)
jae %%elti4
%%lti4:
jmp %4
%%elti4:
%endmacro

%macro lti4_r32_r32 5
cmp %2,%4
jl %%lti4
jne %%elti4
cmp %1,%3
jae %%elti4
%%lti4:
jmp %5
%%elti4:
%endmacro


%macro ltu4_m32_con 3
cmp word [%1+2],((%2) >> 16)
jb %%ltu4
jne %%eltu4
cmp word [%1],((%2) & 0FFFFh)
jae %%eltu4
%%ltu4:
jmp %3
%%eltu4:
%endmacro

%macro ltu4_m32_r32 4
cmp word [%1+2],%3
jb %%ltu4
jne %%eltu4
cmp word [%1],%2
jae %%eltu4
%%ltu4:
jmp %4
%%eltu4:
%endmacro

%macro ltu4_r32_con 4
cmp %2,((%3) >> 16)
jb %%ltu4
jne %%eltu4
cmp %1,((%3) & 0FFFFh)
jae %%eltu4
%%ltu4:
jmp %4
%%eltu4:
%endmacro

%macro ltu4_r32_r32 5
cmp %2,%4
jb %%ltu4
jne %%eltu4
cmp %1,%3
jae %%eltu4
%%ltu4:
jmp %5
%%eltu4:
%endmacro

%macro gtu4_m32_con 3
cmp word [%1+2],((%2) >> 16)
ja %%gtu4
jne %%egtu4
cmp word [%1],((%2) & 0FFFFh)
jbe %%egtu4
%%gtu4:
jmp %3
%%egtu4:
%endmacro

%macro gtu4_m32_r32 4
cmp word [%1+2],%3
ja %%gtu4
jne %%egtu4
cmp word [%1],%2
jbe %%egtu4
%%gtu4:
jmp %4
%%egtu4:
%endmacro

%macro gtu4_r32_con 4
cmp %2,((%3) >> 16)
ja %%gtu4
jne %%egtu4
cmp %1,((%3) & 0FFFFh)
jbe %%egtu4
%%gtu4:
jmp %4
%%egtu4:
%endmacro

%macro gtu4_r32_r32 5
cmp %2,%4
ja %%gtu4
jne %%egtu4
cmp %1,%3
jbe %%egtu4
%%gtu4:
jmp %5
%%egtu4:
%endmacro

%macro gti4_m32_con 3
cmp word [%1+2],((%2) >> 16)
jg %%gti4
jne %%egti4
cmp word [%1],((%2) & 0FFFFh)
jbe %%egti4
%%gti4:
jmp %3
%%egti4:
%endmacro

%macro gti4_m32_r32 4
cmp word [%1+2],%3
jg %%gti4
jne %%egti4
cmp word [%1],%2
jbe %%egti4
%%gti4:
jmp %4
%%egti4:
%endmacro

%macro gti4_r32_con 4
cmp %2,((%3) >> 16)
jg %%gti4
jne %%egti4
cmp %1,((%3) & 0FFFFh)
jbe %%egti4
%%gti4:
jmp %4
%%egti4:
%endmacro

%macro gti4_r32_r32 5
cmp %2,%4
jg %%gti4
jne %%egti4
cmp %1,%3
jbe %%egti4
%%gti4:
jmp %5
%%egti4:
%endmacro


%macro leu4_m32_con 3
cmp word [%1+2],((%2) >> 16)
jb %%leu4
jne %%eleu4
cmp word [%1],((%2) & 0FFFFh)
ja %%eleu4
%%leu4:
jmp %3
%%eleu4:
%endmacro

%macro leu4_m32_r32 4
cmp word [%1+2],%3
jb %%leu4
jne %%eleu4
cmp word [%1],%2
ja %%eleu4
%%leu4:
jmp %4
%%eleu4:
%endmacro

%macro leu4_r32_con 4
cmp %2,((%3) >> 16)
jb %%leu4
jne %%eleu4
cmp %1,((%3) & 0FFFFh)
ja %%eleu4
%%leu4:
jmp %4
%%eleu4:
%endmacro

%macro leu4_r32_r32 5
cmp %2,%4
jb %%leu4
jne %%eleu4
cmp %1,%3
ja %%eleu4
%%leu4:
jmp %5
%%eleu4:
%endmacro

%macro lei4_m32_con 3
cmp word [%1+2],((%2) >> 16)
jl %%lei4
jne %%elei4
cmp word [%1],((%2) & 0FFFFh)
ja %%elei4
%%lei4:
jmp %3
%%elei4:
%endmacro

%macro lei4_m32_r32 4
cmp word [%1+2],%3
jl %%lei4
jne %%elei4
cmp word [%1],%2
ja %%elei4
%%lei4:
jmp %4
%%elei4:
%endmacro

%macro lei4_r32_con 4
cmp %2,((%3) >> 16)
jl %%lei4
jne %%elei4
cmp %1,((%3) & 0FFFFh)
ja %%elei4
%%lei4:
jmp %4
%%elei4:
%endmacro

%macro lei4_r32_r32 5
cmp %2,%4
jl %%lei4
jne %%elei4
cmp %1,%3
ja %%elei4
%%lei4:
jmp %5
%%elei4:
%endmacro

%macro geu4_m32_con 3
cmp word [%1+2],((%2) >> 16)
ja %%geu4
jne %%egeu4
cmp word [%1],((%2) & 0FFFFh)
jb %%egeu4
%%geu4:
jmp %3
%%egeu4:
%endmacro

%macro geu4_m32_r32 4
cmp word [%1+2],%3
ja %%geu4
jne %%egeu4
cmp word [%1],%2
jb %%egeu4
%%geu4:
jmp %4
%%egeu4:
%endmacro

%macro geu4_r32_con 4
cmp %2,((%3) >> 16)
ja %%geu4
jne %%egeu4
cmp %1,((%3) & 0FFFFh)
jb %%egeu4
%%geu4:
jmp %4
%%egeu4:
%endmacro

%macro geu4_r32_r32 5
cmp %2,%4
ja %%geu4
jne %%egeu4
cmp %1,%3
jb %%egeu4
%%geu4:
jmp %5
%%egeu4:
%endmacro

%macro gei4_m32_con 3
cmp word [%1+2],((%2) >> 16)
jg %%gei4
jne %%egei4
cmp word [%1],((%2) & 0FFFFh)
jb %%egei4
%%gei4:
jmp %3
%%egei4:
%endmacro

%macro gei4_m32_r32 4
cmp word [%1+2],%3
jg %%gei4
jne %%egei4
cmp word [%1],%2
jb %%egei4
%%gei4:
jmp %4
%%egei4:
%endmacro

%macro gei4_r32_con 4
cmp %2,((%3) >> 16)
jg %%gei4
jne %%egei4
cmp %1,((%3) & 0FFFFh)
jb %%egei4
%%gei4:
jmp %4
%%egei4:
%endmacro

%macro gei4_r32_r32 5
cmp %2,%4
jg %%gei4
jne %%egei4
cmp %1,%3
jb %%egei4
%%gei4:
jmp %5
%%egei4:
%endmacro

%macro eqi4_m32_con 3
cmp word [%1+2],((%2) >> 16)
jne %%eeqi4
cmp word [%1],((%2) & 0FFFFh)
jne %%eeqi4
jmp %3
%%eeqi4:
%endmacro

%macro eqi4_m32_r32 4
cmp word [%1+2],%3
jne %%eeqi4
cmp word [%1],%2
jne %%eeqi4
jmp %4
%%eeqi4:
%endmacro

%macro eqi4_r32_con 4
cmp %2,((%3) >> 16)
jne %%eeqi4
cmp %1,((%3) & 0FFFFh)
jne %%eeqi4
jmp %4
%%eeqi4:
%endmacro

%macro eqi4_r32_r32 5
cmp %2,%4
jne %%eeqi4
cmp %1,%3
jne %%eeqi4
jmp %5
%%eeqi4:
%endmacro

%macro nei4_m32_con 3
cmp word [%1+2],((%2) >> 16)
jne %%nei4
cmp word [%1],((%2) & 0FFFFh)
je %%enei4
%%nei4:
jmp %3
%%enei4:
%endmacro

%macro nei4_m32_r32 4
cmp word [%1+2],%3
jne %%nei4
cmp word [%1],%2
je %%enei4
%%nei4:
jmp %4
%%enei4:
%endmacro

%macro nei4_r32_con 4
cmp %2,((%3) >> 16)
jne %%nei4
cmp %1,((%3) & 0FFFFh)
je %%enei4
%%nei4:
jmp %4
%%enei4:
%endmacro

%macro nei4_r32_r32 5
cmp %2,%4
jne %%nei4
cmp %1,%3
je %%enei4
%%nei4
jmp %5
%%enei4:
%endmacro

%define movl_di_di
%define movl_si_si

%macro movl_di_si 0
cli
push ds
pop es
push si
pop di
sti
%endmacro

%macro movl_si_di 0
cli
push es
pop ds
push di
pop si
sti
%endmacro

%macro movl_bx_ax 0
mov bx,ax
mov cx,dx
%endmacro

%macro movl_ax_bx 0
mov ax,bx
mov dx,cx
%endmacro

%macro rshu4 2
or cx,cx
jz %%ershu4
%%rshu4:
sar dx,1
rcr ax,1
loop %%rshu4
%%ershu4:
%endmacro

%macro rshi4 2
or cx,cx
jz %%ershi4
%%rshi4:
sar dx,1
rcr ax,1
loop %%rshi4
%%ershi4:
%endmacro

%macro lshi4 2
or cx,cx
jz %%elshi4
%%lshi4:
sal ax,1
rcl dx,1
loop %%lshi4
%%elshi4:
%endmacro

%macro lshu4 2
or cx,cx
jz %%elshu4
%%lshu4:
sal ax,1
rcl dx,1
loop %%lshu4
%%elshu4:
%endmacro

BITS 16
EXTERN __divi4
EXTERN __divu4
EXTERN __modi4
EXTERN __modu4
EXTERN __muli4
EXTERN __mulu4
EXTERN __cvu_di
EXTERN __cvp_di
EXTERN __addp_di
EXTERN __cvu_si
EXTERN __cvp_si
EXTERN __addp_si
EXTERN __call
EXTERN __jmp
EXTERN __fchs
EXTERN __fldd_di
EXTERN __fldd_si
EXTERN __fldd_bx
EXTERN __fldd_sp
EXTERN __fldl_di
EXTERN __fldl_si
EXTERN __fldl_bx
EXTERN __fldl_sp
EXTERN __fstpd_si
EXTERN __fstpd_di
EXTERN __fstpd_bx
EXTERN __fstpd_sp
EXTERN __fstpl_si
EXTERN __fstpl_di
EXTERN __fstpl_bx
EXTERN __fstpl_sp
EXTERN __fdiv
EXTERN __fadd
EXTERN __fsub
EXTERN __fmul
EXTERN __ftos
EXTERN __ftoi
EXTERN __ftol
EXTERN __fistps_bx
EXTERN __fistps_di
EXTERN __fistps_si
EXTERN __fistps_sp
EXTERN __fistpl_bx
EXTERN __fistpl_di
EXTERN __fistpl_si
EXTERN __fistpl_sp
EXTERN __filds_bx
EXTERN __filds_di
EXTERN __filds_si
EXTERN __filds_sp
EXTERN __fildd_di
EXTERN __fildd_bx
EXTERN __fildd_si
EXTERN __fildd_sp
EXTERN __fcomp
%define SEG0 0
